/*
ID: espr1t
TASK: Closest Points
KEYWORDS: Wrong solution (Should get ~30 points)
*/

#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;
FILE* in = stdin; FILE* out = stdout;

const int MAX = 100000;
const int DIM = 5;
const long long INF = 1000000000000000001LL;

long long sqr(long long a) {
    return a * a;
}

int n, k, q;
int a[MAX][DIM], b[MAX][DIM];

void solve() {
    // For each coordinate, look for the 100 closest by this coordinate points
    const int DIST = 100;

    vector < pair <int, int> > sorted[DIM];
    for (int dim = 0; dim < k; dim++) {
        for (int i = 0; i < n; i++)
            sorted[dim].push_back(make_pair(a[i][dim], i));
        sort(sorted[dim].begin(), sorted[dim].end());
    }
    
    for (int i = 0; i < q; i++) {
        long long minn = INF;
        for (int dim = 0; dim < k; dim++) {
            int left = 0, right = (int)sorted[dim].size() - 1;
            while (left <= right) {
                int mid = (left + right) / 2;
                if (sorted[dim][mid].first < b[i][dim])
                    left = mid + 1;
                else
                    right = mid - 1;
            }
            for (int c = max(0, right - DIST); c < min(n, right + DIST); c++) {
                long long cur = 0;
                for (int d = 0; d < k; d++)
                    cur += sqr(b[i][d] - a[sorted[dim][c].second][d]);
                minn = min(minn, cur);
            }
        }
        fprintf(out, "%.3lf\n", sqrt((double)minn));
    }
}

void readInput() {
    fscanf(in, "%d %d", &n, &k);
    for (int i = 0; i < n; i++)
        for (int c = 0; c < k; c++)
            fscanf(in, "%d", &a[i][c]);
    fscanf(in, "%d", &q);
    for (int i = 0; i < q; i++)
        for (int c = 0; c < k; c++)
            fscanf(in, "%d", &b[i][c]);
}

int main(void) {
//    in = fopen("ClosestPoints.in", "rt"); //out = fopen("ClosestPoints.out", "wt");
    
    readInput();
    solve();
    
    return 0;
}
